﻿Type=Class
Version=7.01
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Custom View class 
#Event: Click (text as string)
#Event: MouseMove (text as string)

'#DesignerProperty: Key: Text, DisplayName: Text, FieldType: String, DefaultValue: Testing scrolling text, Description: Text to be added to scroll.
'#DesignerProperty: Key: SeparatorImage, DisplayName: Separator image, FieldType: ImageView , DefaultValue: Null, Description: This image will be displayed between text lines.
#DesignerProperty: Key: ScrollingDirection, DisplayName: Scrolling Direction, FieldType: int, DefaultValue: 0, Description: Scrolling Direction UP/DOWN/LEFT/RIGHT.

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As Panel
	Private Const DefaultColorConstant As Int = -984833 'ignore
	Public Text As String
	Public Const DIRECTION_LEFT As Int=0
	Public Const DIRECTION_RIGHT As Int=1
	Public Const DIRECTION_UP As Int=2
	Public Const DIRECTION_DOWN As Int=3
	
	
	
	Private ScrollinDirection As Int

	
	Private ObjectsCollection As Map
	Private scrView As Panel
	
 
	Private mSpeed As Int= 10000
	Private animator As AnimationPlus
	'Private Direction As ScrollingDirection
	 Private Canvas1 As Canvas
	
End Sub
'Don´t modify these lines
'Initialize Custom View - Used by Designer and by code via AddToParent
'Initialize(Me,"event")
Public Sub Initialize (vCallback As Object, vEventName As String)
	mCallBack = vCallback
	mEventName = vEventName
	ObjectsCollection.Initialize
End Sub
Public Sub SetDirection (Direction As Int)
	ScrollinDirection=Direction
	  
End Sub

private Sub Reorder 'Chenge the elements order for right to left direction and vise-versa
	
	Dim maxX As Int
	
	For Each item In ObjectsCollection.Keys
		Dim iObject As View=ObjectsCollection.Get(item)
		If iObject.IsInitialized Then
		maxX=maxX + iObject.Width


		Select Case ScrollinDirection
			Case DIRECTION_RIGHT
				iObject.left =scrView.Width-maxX  'Shift all controls to the right to free space for the new object
			Case DIRECTION_LEFT
				iObject.left = maxX -iObject.Width
		End Select
		End If
	Next
End Sub
'
'Public Sub Initialize (Callback As Object, EventName As String)
'	mEventName = EventName
'	mCallBack = Callback
'	ObjectsCollection.Initialize
'	ObjectsCollection.Initialize
' 
'	
'	
'End Sub
 
public Sub StartScrolling(Speed As Int)
	
	mSpeed=Speed
 	Select Case ScrollinDirection
		Case DIRECTION_RIGHT
			animator.InitializeTranslate("animator",-scrView.Width-mBase.Width,0,mBase.Width,0)
		Case DIRECTION_LEFT
			animator.InitializeTranslate("animator",0,0,-scrView.Width - mBase.Width ,0)
	End Select
	
	animator.RepeatMode = animator.REPEAT_RESTART
	animator.PersistAfter =True
	animator.StartOffset=100
	animator.RepeatCount=-1
	animator.Duration=Speed
	animator.SetInterpolator( animator.INTERPOLATOR_LINEAR)
	
	animator.Start (scrView)
	
End Sub
Sub animator_AnimationRepeat
	animator.Stop(scrView)
	Reorder
	StartScrolling(mSpeed)
	
End Sub
Public Sub CreateView
	'example view code
	mBase.Color = Colors.Transparent
	scrView.Initialize(mBase.Height)
	mBase.AddView(scrView,0,0,mBase.Width,mBase.Height)
End Sub
Public Sub DesignerCreateView (Base As Panel, Lbl As Label, Props As Map)
	mBase = Base
	scrView.Initialize(mBase.Height)
	mBase.AddView (scrView,mBase.Width,0,1,1)
	scrView. Width=mBase.Width
	scrView. Height=mBase.Height
	Canvas1.Initialize(mBase)
	scrView.Color=Colors.Transparent
 
End Sub

Public Sub GetBase As Panel
	Return mBase
End Sub
 
Public Sub AddText(TextString As String, TextID As String,Color As Int,TextSize As Int,Gravi As Int)
	
	
	
	Dim nLable As Label
	nLable.Initialize("")
	nLable.Color=Colors.Transparent
	nLable.TextColor=Color
	nLable.Gravity =Gravi
	
	nLable.Textsize=TextSize
	nLable.Typeface = Typeface.DEFAULT
	nLable.Text=TextString

	
	Dim textheight As Int= Canvas1.MeasureStringHeight(TextString,Typeface.DEFAULT ,nLable.Textsize)*2
	Dim TextWidth As Int= Canvas1.MeasureStringWidth(TextString,Typeface.DEFAULT ,nLable.Textsize)+10
	If scrView.Height > textheight Then textheight=scrView.Height
	
	
	AddObjectToPanel( nLable,TextWidth,textheight,TextID)
	
End Sub

public Sub AddObjectToPanel( nObject As View,width As Int,height As Int,ID As String)
	Dim maxX As Int=0,maxy As Int =height
	
	For Each item In ObjectsCollection.Keys
		Dim iObject As View=ObjectsCollection.Get(item)
		
		maxX=maxX + iObject.Width
		If maxy < iObject.Height Then maxy=iObject.Height
		Select Case ScrollinDirection
			Case DIRECTION_RIGHT
				iObject.left =iObject.left + width 'Shift all controls to the right to free space for the new object
		End Select
		
	Next
	
	
	scrView.Width =maxX+width
	scrView.Height=maxy

	Select Case ScrollinDirection
		Case DIRECTION_LEFT
			scrView.AddView(nObject,maxX ,0 ,  width, height)
		
		Case DIRECTION_RIGHT
			scrView.AddView(nObject,0,0 ,  width, height)
	End Select
	
	
	
	ObjectsCollection.put  (ID,nObject)
End Sub
private Sub RemoveObjectFromPanel(panel As Panel,ID As String	)
	Dim Shift As Int
	For Each item  In ObjectsCollection.Keys
		Dim iObj As View=ObjectsCollection.Get(item)
		
		
		If item=ID Then
			Shift= iObj.Width
			ObjectsCollection.Remove  (ID)
			iObj.RemoveView
			Exit
		Else
'			If Shift>0 Then
'				iObj.Left = iObj.Left - Shift
'			End If
		End If
		
	Next
	
	panel.Width=panel.Width- Shift
	Reorder
End Sub

Public Sub RemoveObject(ID As String)
	If ObjectsCollection.ContainsKey( ID) Then
		RemoveObjectFromPanel(scrView,ID)
		
		
	End If
End Sub
#region getters and setters

'CustomView basic dimensions
Sub getTop As Int
	Return mBase.Top
End Sub

Sub setTop(n As Int)
	mBase.Top = n
End Sub

Sub getLeft As Int
	Return mBase.Left
End Sub

Sub setLeft(n As Int)
	mBase.Left = n
End Sub

Sub getWidth As Int
	Return mBase.width
End Sub

Sub setWidth(n As Int)
	mBase.width = n
End Sub

Sub getHeight As Int
	Return mBase.Height
End Sub

Sub setHeight(n As Int)
	mBase.Height = n
End Sub

#end region